/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AddressbooksSynchronizer.
 *
 * The Initial Developer of the Original Code is Gnter Gersdorf.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Gnter Gersdorf <G.Gersdorf@ggbs.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var gDoc;
var gWindow;
var gSingleBook;

var gLifeTime;
var abURI=null;
var ioService=Components.classes["@mozilla.org/network/io-service;1"]
               .getService(Components.interfaces.nsIIOService);

var gMabFiles;
var mabName;
var mabFile;
var warn=0;
var usePost=false;

var strings;
var syncing;
var externalApp;
var externalAppHandler;

var cleanUp=null;
var gAbort=0;

var gForce;
var gCheckLastMod=true;

function downloadDone() {
//alert('app='+externalApp+' handler='+externalAppHandler);
  if (externalApp) {
    syncprotocol = pref.getCharPref("extensions.addressbookssync.protocol");
    if (externalApp==-1)
      pref.clearUserPref("network.protocol-handler.external."+syncprotocol);
    else
      pref.setBoolPref("network.protocol-handler.external."+syncprotocol, true);
  }
  if (externalAppHandler)
    pref.setCharPref("network.protocol-handler.app."+syncprotocol, externalAppHandler);
  externalApp=null;
  externalAppHandler=null;
//TODO: appstarttime auf aktuelle zeit setzen?
}

//TODO: welche Addressbcher sind auf dem Server zu finden!?
function download(singleBook, force)
{
dump('in download appstart='+gAddressbooksSync.appstarttime+' state='+gAddressbooksSync.state+'\n');

  gLifeTime=3;
  gForce=force||gAddressbooksSync.forceDownload;
    gAddressbooksSync.forceDownload=false;
  gCheckLastMod = gAddressbooksSync.checkLastModTime;
  var synctype=gAddressbooksSync.synctype;

  syncing=true;
  gUsesPopup=window.location=='chrome://addressbookssync/content/download.xul';
  if (gUsesPopup) {
//    window.moveTo(0,0);
      //v could be removed in next version!
        var dialogElement = document.documentElement;
        dialogElement.removeAttribute("persist");
        dialogElement.removeAttribute("height");
        dialogElement.removeAttribute("width");
        dialogElement.removeAttribute("screenX");
        dialogElement.removeAttribute("screenY");
      //^
  }
  strings = document.getElementById("strings");

  statustxt(synctype, -1, false, 'Start download ('+synctype+')');

  gAddressbooksSync.count=0;
  gSingleBook=singleBook;
  gMabFiles=(singleBook ? new Array(singleBook) : syncedAddressbooks('down'));

  if (synctype=='local') {
    gTempName='abstemp.mab';
    if (gUsesPopup) setTimeout(getLocalData, 0);  // need time to show the popup
    else getLocalData();
  } else if (synctype=='remote') {
    gTempName='abstemp.mab';
    abURI=getSyncURI(false);
    try{ syncprotocol = pref.getCharPref( "extensions.addressbookssync.protocol" ); }
      catch(e){ killMe();}
    try { externalApp=pref.getBoolPref("network.protocol-handler.external."+syncprotocol); }
      catch(e) { externalApp=-1; }
    if (externalApp) pref.setBoolPref("network.protocol-handler.external."+syncprotocol, false);
    //ubuntu seems to ignore the value of external.xxx, therefore:
    try {
      externalAppHandler=pref.getCharPref("network.protocol-handler.app."+syncprotocol);
      if (externalAppHandler) pref.clearUserPref("network.protocol-handler.app."+syncprotocol);
    } catch(e) { externalAppHandler=''; }
    cleanUp=downloadDone;
    try { usePost=pref.getBoolPref("extensions.addressbookssync.usepost"); }
      catch(e) { usePost=false; }
    if (gUsesPopup) setTimeout(getData, 0);
    else getData();
  } else if (synctype=='imap') {
    if (gUsesPopup) setTimeout(imapLoad, 0);
    else imapLoad();
  } else {
    killMe();
  }
}

function getLocalData() {
  var localpath=pref.getCharPref( "extensions.addressbookssync.localpath" )
  if (!localpath) { //preferences not set!
    killMe();
    return;
  }
  var dir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
  dir.initWithPath( localpath );
  for (var i = 0; i < gMabFiles.length; i++) {
    if (gAbort) break;
    var mabFile=gMabFiles[i];
    var cur=getAddressBook(mabFile);
    var mabName=cur.directoryProperties.description;
    var uri = cur.directoryProperties.URI;

    if ((gForce || !gCheckLastMod) && !askOverwrite(cur, false)) {
      statustxt('- '+mabName+" "+strings.getString('skipped'), 3, false);
      continue;
    }

    var localFileName;
    if (!syncing || uri!=kPersonalAddressbookURI && uri!=kCollectedAddressbookURI)
      localFileName = mabName+'.mab'; //ex: =mabFile
    else
      localFileName = '_tb_'+cur.directoryProperties.fileName;

    statustxt('- '+mabName+'..', 1, false);

    var file = Components.classes["@mozilla.org/file/local;1"].
      createInstance(Components.interfaces.nsILocalFile);
    file.initWithFile( dir );
    file.appendRelativePath( localFileName );
    if (!file.exists()) {
      statustxt(strings.getString('nofile'), 2, true, null, file.path);
      continue;
    }
    var localMabFile = getDir('ProfD');
    localMabFile.appendRelativePath( mabFile );
    lmfd=timeString(localMabFile.lastModifiedTime);
    lfd=timeString(file.lastModifiedTime);
    lms='lastMod mab:'+lmfd+' file:'+lfd;

    if (!gForce && gCheckLastMod) {
      if (localMabFile.lastModifiedTime >= file.lastModifiedTime) {
        statustxt(strings.getString('skipped'), 2, false, null, lms);
        continue;
      } else if (!askOverwrite(cur, false)) {
        statustxt(strings.getString('skipped'), 2, false, null, 'Policy: '+gAddressbooksSync.downloadpolicy);
        continue;
      }
    }

    var ret;
    if ((ret=replaceAddressBook(mabName, mabFile, file))) {
      statustxt(strings.getString('notcopied'), 2, true, null, ret);
    } else {
      statustxt(strings.getString('copied'), 2, false, null, lms);
      gAddressbooksSync.count+=1;
    }
///
  }
  if (gSingleBook) alert(strings.getString('loaded'));
  killMe();
}

function getData()
{
  if (gAbort) {
    killMe();
    return;
  }
  if (!checkOffline('download')) return;

  mabFile=gMabFiles.pop();
  if (!mabFile) {
    if (warn) gLifeTime=5;//a little bit longer
    if (gSingleBook) alert(strings.getString('loaded'));
    killMe();
    return;
  }
  var cur=getAddressBook(mabFile);
  mabName=cur.directoryProperties.description;
  var uri = cur.directoryProperties.URI;

  if ((gForce || !gCheckLastMod) && !askOverwrite(cur, false)) {
      statustxt('- '+mabName+" "+strings.getString('skipped'), 3, false);
      getData();
      return;
  }

  var remoteFileName;
  if (!syncing || uri!=kPersonalAddressbookURI && uri!=kCollectedAddressbookURI) {
    remoteFileName = mabName+".mab";
  } else {
    remoteFileName = '_tb_'+cur.directoryProperties.fileName;
  }
  statustxt('- '+mabName+".", 1, false);  // 1. dot: start

  var mabURI=abURI+remoteFileName;
  var URI=ioService.newURI(mabURI,null,null);

/*
  var protService=Components.classes["@mozilla.org/uriloader/external-protocol-service;1"]
               .getService(Components.interfaces.nsIExternalProtocolService);
  //Windows: from Registry HKCR\ftp\shell\open\command
  //Unix:    form preferences network.protocol-handler.app.
  if (protService.externalProtocolHandlerExists(URI.scheme)) {
    alert('external Protocol handler for '+URI.scheme+': '+
      protService.getApplicationDescription(URI.scheme));
  }
*/

  var flmt=null;
  if (!gForce && gCheckLastMod) {
    //check for last modified date on download
    var localMabFile = getDir('ProfD');
    localMabFile.appendRelativePath( mabFile );
    var flmt=new Date(localMabFile.lastModifiedTime);
  }
//wenn keine ausgabe der lastmod time: forcierter download!!
  var s=flmt?'lastMod mabfile:'+timeString(flmt):null;
  statustxt(".", 0, false, null, s); // 2. dot: start of download

  var error=gBookmarksSynchronizerDownloadService.start(URI, downloadCallback, usePost, flmt, cur);
  if(error)
    downloadCallback("done", error);
  else
    statustxt(".", 0, false); // 3. dot: download started
}

function downloadCallback(aStatus,aError)
{
  if(aStatus != "done" && aError==0)
    return;

  switch(aError){
    case -2:
      return;
      break;
    case 0:
      var s=gBookmarksSynchronizerDownloadService.remoteLastModTime?
        'lastMod remote: '+timeString(gBookmarksSynchronizerDownloadService.remoteLastModTime)
        :null;
      statustxt(".", 0, false, null, s); // 4. dot: download complete
      try{
        var abData=gBookmarksSynchronizerDownloadService.data;
        //Data must start with: // <!-- <mdb:mork:z v="1.4"/> --> otherwise its an HTML error page
        if (abData.substr( 0, 19 )=='// <!-- <mdb:mork:z') {
          var nsITmpFile = getDir('TmpD');
          nsITmpFile.appendRelativePath( gTempName );
          //file.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0664);
          writeMabData(nsITmpFile, abData);
          statustxt(".", 0, false); // 5. dot: file written
          var err=replaceAddressBook(mabName, mabFile, nsITmpFile);
          if (err) {
            statustxt(err, 2, true);
            break;
          }
          statustxt(strings.getString('ok'), 2, false);
          gAddressbooksSync.count+=1;
          gWindow.abs_init(); // update options list, if necessary
        } else {    //try to extract error message from <title> tag
          if(abData.match(/<title>(\d+).*<\/title>/i))
            statustxt(errorstr(RegExp.$1), 2, true);
          else
            statustxt(strings.getString('failed'), 2, true);
          warn=1;
        }
      } catch(e) {
        if(e && e.toString().match(/^absync\:(.+)$/))
          statustxt(RegExp.$1, 2, true);
      }
      break;
    case 0x804b0002: // NS_BINDING_ABORTED: Download stopped because of timecheck
      var s=gBookmarksSynchronizerDownloadService.remoteLastModTime?
        'lastMod remote: '+timeString(gBookmarksSynchronizerDownloadService.remoteLastModTime)
        :'Policy: '+gAddressbooksSync.downloadpolicy;
      statustxt(strings.getString('skipped'), 2, false, null, s);
      break;
    default:
      statustxt(errorstr(aError), 2, true);
      break;
  }
  if (gUsesPopup) getData();  // next addressbook
  else setTimeout(getData, 1000);
}

function cancelDownload()
{
  if (gAbort) {
    gAddressbooksSync.state=''; //Up-/Download ready
    gAbort++;
    killMe();
  } else {
    gAbort++;
    document.getElementById("abs_cancel").label='kill';
  }
  //gBookmarksSynchronizerDownloadService.cancel(); //No, or we may left behind with corrupt mabs
}


