/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AddressbooksSynchronizer.
 *
 * The Initial Developer of the Original Code is Gnter Gersdorf.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Gnter Gersdorf <G.Gersdorf@ggbs.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var strings;


function abs_init()
{
//gAddressbooksSync.doTest();

    strings = document.getElementById("strings");

    var localpath;

    var syncprotocol;
    var synchost='';
    var syncuser='';
    var syncpassword='';
    var syncpath='';
    var syncimap='';
    var usepost=false;
    var syncpolicy='';
    var synctype='none';
    var imappolicy=true;

    synctype = gAddressbooksSync.synctype;

    try{ localpath = pref.getCharPref( "extensions.addressbookssync.localpath" ); } catch(e){ localpath=''; }

    try{ syncprotocol = pref.getCharPref( "extensions.addressbookssync.protocol" ); } catch(e){}
    try{ synchost = pref.getCharPref( "extensions.addressbookssync.host" ); } catch(e){}
    try{ syncuser = pref.getCharPref( "extensions.addressbookssync.user" ); } catch(e){}
    //try{ syncpassword = get_password(synchost, syncuser); } catch(e){}
    syncpassword = '**********';
    try{ syncpath = pref.getCharPref( "extensions.addressbookssync.path" ); } catch(e){}

    try{ syncimap = pref.getCharPref( "extensions.addressbookssync.imapfolder" ); } catch(e){}

    try{ syncpolicy = pref.getCharPref( "extensions.addressbookssync.syncpolicy" ); }
      catch(e){ syncpolicy='entry'; }
    try{ imappolicy = pref.getBoolPref( "extensions.addressbookssync.imapusedraft" ); }
      catch(e){ imappolicy=true; }

    if (synctype=='local') {
      document.getElementById("synctype").selectedItem=document.getElementById("synclocal");
      document.getElementById("absTabLocal").selected=true;
      document.getElementById("absTabRemote").selected=false;
      document.getElementById("absTabIMAP").selected=false;
      document.getElementById("absTab").selectedIndex=0;
    } else if (synctype=='remote') {
      document.getElementById("synctype").selectedItem=document.getElementById("syncremote");
      document.getElementById("absTabLocal").selected=false;
      document.getElementById("absTabRemote").selected=true;
      document.getElementById("absTabIMAP").selected=false;
      document.getElementById("absTab").selectedIndex=1;
    } else if (synctype=='imap') {
      document.getElementById("synctype").selectedItem=document.getElementById("syncimap");
      document.getElementById("absTabLocal").selected=false;
      document.getElementById("absTabRemote").selected=false;
      document.getElementById("absTabIMAP").selected=true;
      document.getElementById("absTab").selectedIndex=2;
    }

    document.getElementById("localpath").value = localpath;

    document.getElementById("protocol").value = syncprotocol;
    document.getElementById("host").value = synchost;
    document.getElementById("username").value = syncuser;
    document.getElementById("password").value = syncpassword;
    document.getElementById("path").value = syncpath;

    PickedMsgFolder(syncimap);

    document.getElementById("autoupload").checked = gAddressbooksSync.autoupload;
    document.getElementById("autodownload").checked = gAddressbooksSync.autodownload;
    document.getElementById("timedupload").checked = gAddressbooksSync.timedupload;
    document.getElementById("timeddownload").checked = gAddressbooksSync.timeddownload;
    document.getElementById("loadtimer").value = gAddressbooksSync.loadtimer;

    if (syncpolicy=='entry')
      document.getElementById("syncpolicy").selectedItem=document.getElementById("syncpolicyentry")
    else if (syncpolicy=='file')
      document.getElementById("syncpolicy").selectedItem=document.getElementById("syncpolicyfile")

    if (imappolicy)
      document.getElementById("imappolicy").selectedItem=document.getElementById("imappolicydraft")
    else
      document.getElementById("imappolicy").selectedItem=document.getElementById("imappolicyfile")
    document.getElementById("separateupdown").checked = gAddressbooksSync.separateupdown;

    var downloadpolicy=gAddressbooksSync.downloadpolicy;
    if (downloadpolicy=='ask')
      document.getElementById("downloadpolicy").selectedItem=document.getElementById("downloadpolicyask")
    else if (downloadpolicy=='overwrite')
      document.getElementById("downloadpolicy").selectedItem=document.getElementById("downloadpolicyoverwrite")
    else if (downloadpolicy=='keep')
      document.getElementById("downloadpolicy").selectedItem=document.getElementById("downloadpolicykeep")

    // list address books
    var mabList = document.getElementById("MabList");
    var mabList1 = document.getElementById("MabList1");
    var syncList = document.getElementById("SyncListCheck");
    //just in case
    mabList.removeAllItems();
    mabList1.removeAllItems();
    while (syncList.firstChild)
      syncList.removeChild(syncList.firstChild);
    document.getElementById("SyncLiscDesc").style.visibility =
      (gAddressbooksSync.separateupdown?'visible':'hidden');

    // get all MAB Files
    var selectedMAB='';
    var mabFiles=syncedAddressbooks('all');
    for (mabFile in mabFiles) {
      var description=mabFiles[mabFile].description;

      mabList.appendItem( description, mabFile, "" ); // 'Store'
      mabList1.appendItem( description, mabFile, "" ); // 'Store'

      //'Sync'
      var hb=document.createElement('hbox');
      if (gAddressbooksSync.separateupdown) {
        var ncb1=document.createElement('checkbox');
        ncb1.setAttribute('id', 'addressbookssync_'+description+'_up');
        ncb1.setAttribute('label', null);
        hb.appendChild(ncb1);
      }
      var ncb=document.createElement('checkbox');
      ncb.setAttribute('id', 'addressbookssync_'+description);
      ncb.setAttribute('label', description);
      hb.appendChild(ncb);
      syncList.appendChild( hb );

      var prefName = mabFiles[mabFile].prefName;
      var sync=false;
      if (!gAddressbooksSync.separateupdown) {
        try { sync = pref.getBoolPref( prefName+".extensions.addressbookssync" ); } catch(e) { sync=false; }
        if (sync) {
          ncb.setAttribute('checked', true);
          selectedMAB=description;
        }
      } else {
        try { sync = pref.getBoolPref( prefName+".extensions.addressbookssync.up" ); } catch(e) { sync=false; }
        if (sync) {
          ncb1.setAttribute('checked', true);
          selectedMAB=description;
        }
        try { sync = pref.getBoolPref( prefName+".extensions.addressbookssync.down" ); } catch(e) { sync=false; }
        if (sync) {
          ncb.setAttribute('checked', true);
          selectedMAB=description;
        }
      }
    } // for
    mabList.selectedIndex = 0;
    mabList1.selectedIndex = 0;

    if (!selectedMAB) selectedMAB='???';
    selectedMAB+='.mab';
    document.getElementById("URI").value = getSyncURI(true)+selectedMAB;

    try{ usepost = pref.getBoolPref( "extensions.addressbookssync.usepost" ); } catch(e){ usepost=false; }
    document.getElementById("usepost").checked = usepost;

    document.getElementById("notimecheck").checked = !gAddressbooksSync.checkLastModTime;
    document.getElementById("hidepopups").checked = gAddressbooksSync.hidepopups;
    document.getElementById("hideallpopups").checked = gAddressbooksSync.hideallpopups;
    document.getElementById("noupload").checked = gAddressbooksSync.noupload;

    if (gAddressbooksSync.noupload) disableUpload();

} // init



function abs_finish()
{
    if (!document.getElementById("localpath")) return;  // called via toolbar buttons

    var localpath=document.getElementById("localpath").value;
    pref.setCharPref( "extensions.addressbookssync.localpath", localpath );
    if ( document.getElementById("synclocal").selected && localpath) {
      if (gAddressbooksSync.synctype!='local') {
        gAddressbooksSync.forceUpload=true;
        gAddressbooksSync.forceDownload=true;
      }
      gAddressbooksSync.synctype='local';
    } else if ( document.getElementById("syncremote").selected ) {
      if (gAddressbooksSync.synctype!='remote') {
        gAddressbooksSync.forceUpload=true;
        gAddressbooksSync.forceDownload=true;
      }
      gAddressbooksSync.synctype='remote';
    } else if ( document.getElementById("syncimap").selected ) {
      if (gAddressbooksSync.synctype!='imap') {
        gAddressbooksSync.forceUpload=true;
        gAddressbooksSync.forceDownload=true;
      }
      gAddressbooksSync.synctype='imap';
    } else {
      gAddressbooksSync.synctype='none';
      document.getElementById("synctype").selectedItem=null;
    }

    pref.setCharPref( "extensions.addressbookssync.protocol", document.getElementById("protocol").value );
    var host=document.getElementById("host").value;  pref.setCharPref( "extensions.addressbookssync.host", host );
    var user=document.getElementById("username").value; pref.setCharPref( "extensions.addressbookssync.user", user );
    var pwd=document.getElementById("password").value;
    if (pwd!='**********') set_password(host,user,document.getElementById("password").value );
    pref.setCharPref( "extensions.addressbookssync.path", document.getElementById("path").value );
    pref.setCharPref( "extensions.addressbookssync.imapfolder", document.getElementById("syncimapPicker").getAttribute("uri"));

    var v=document.getElementById("autoupload").checked;
    if (!gAddressbooksSync.autoupload && v) gAddressbooksSync.forceUpload=true;
    gAddressbooksSync.autoupload=v;
    v=document.getElementById("autodownload").checked;
    if (!gAddressbooksSync.autodownload && v) gAddressbooksSync.forceDownload=true;
    gAddressbooksSync.autodownload=v;

    gAddressbooksSync.timedupload=document.getElementById("timedupload").checked;
    gAddressbooksSync.timeddownload=document.getElementById("timeddownload").checked;
    var timer=gAddressbooksSync.loadtimer;
    gAddressbooksSync.loadtimer=document.getElementById("loadtimer").value;

    if ( document.getElementById("syncpolicyentry").selected)
      pref.setCharPref( "extensions.addressbookssync.syncpolicy", 'entry' );
    else if ( document.getElementById("syncpolicyfile").selected )
      pref.setCharPref( "extensions.addressbookssync.syncpolicy", 'file' );

    if ( document.getElementById("imappolicydraft").selected)
      pref.setBoolPref( "extensions.addressbookssync.imapusedraft", true );
    else if ( document.getElementById("imappolicyfile").selected )
      pref.setBoolPref( "extensions.addressbookssync.imapusedraft", false );

    if ( document.getElementById("downloadpolicyask").selected)
      gAddressbooksSync.downloadpolicy='ask';
    else if ( document.getElementById("downloadpolicyoverwrite").selected )
      gAddressbooksSync.downloadpolicy='overwrite';
    else if ( document.getElementById("downloadpolicykeep").selected )
      gAddressbooksSync.downloadpolicy='keep';

    var old_separateupdown=gAddressbooksSync.separateupdown;
    gAddressbooksSync.separateupdown=document.getElementById("separateupdown").checked;

    var mabFiles=syncedAddressbooks('all');
    var selectedMab='???';
    for (mabFile in mabFiles) {
      var description=mabFiles[mabFile].description;
      var prefName = mabFiles[mabFile].prefName;
      if (!old_separateupdown) {
        var syncElem = document.getElementById('addressbookssync_'+description);
        if (syncElem.getAttribute('checked')) {
          try { cbv=pref.getBoolPref(prefName+".extensions.addressbookssync"); } catch(e) { cbv=false; };
          gAddressbooksSync.forceUploadOf(mabFile, !cbv);
          pref.setBoolPref( prefName+".extensions.addressbookssync", true );
          selectedMAB=description;
        } else {
          pref.setBoolPref( prefName+".extensions.addressbookssync", false );
          gAddressbooksSync.forceUploadOf(mabFile, false);
        }
      } else {
        var syncElem = document.getElementById('addressbookssync_'+description+'_up');
        if (syncElem.getAttribute('checked')) {
          gAddressbooksSync.forceUploadOf(mabFile,
            !pref.getBoolPref(prefName+".extensions.addressbookssync.up"));
          pref.setBoolPref( prefName+".extensions.addressbookssync.up", true );
          selectedMAB=description;
        } else {
          pref.setBoolPref( prefName+".extensions.addressbookssync.up", false );
          gAddressbooksSync.forceUploadOf(mabFile, false);
        }
        syncElem = document.getElementById('addressbookssync_'+description);
        if (syncElem.getAttribute('checked')) {
          pref.setBoolPref( prefName+".extensions.addressbookssync.down", true );
          selectedMAB=description;
        } else
          pref.setBoolPref( prefName+".extensions.addressbookssync.down", false );
      }
    }
    selectedMAB+='.mab';
    document.getElementById("URI").value = getSyncURI(true)+selectedMAB;

    pref.setBoolPref( "extensions.addressbookssync.usepost", document.getElementById("usepost").checked );

    gAddressbooksSync.checkLastModTime=!document.getElementById("notimecheck").checked;
    gAddressbooksSync.hidepopups=document.getElementById("hidepopups").checked;
    gAddressbooksSync.hideallpopups=document.getElementById("hideallpopups").checked;
    gAddressbooksSync.noupload=document.getElementById("noupload").checked;

    if (gAddressbooksSync.separateupdown!=old_separateupdown) abs_init(); // must rebuild!
} // finish



function ChooseFile()
{
  var nsIFilePicker = Components.interfaces.nsIFilePicker;
  var filePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);

  var x=strings.getString("choosefile");
  filePicker.init(window, x, nsIFilePicker.modeOpen);
  filePicker.appendFilter( strings.getString("mab") + " (*.mab)", "*.mab;" );

  if( filePicker.show() == nsIFilePicker.returnOK )
  {
    document.getElementById( "MabFilePath" ).value = filePicker.file.path;
    var mabFileName = filePicker.file.leafName;
    var mabName = mabFileName.substr( 0, mabFileName.lastIndexOf(".") );
//    mabName = mabName.replace( /_/g, " " );
    document.getElementById( "MabName" ).value = mabName;
  }
} // ChooseFile

function ChoosePath()
{
  var nsIFilePicker = Components.interfaces.nsIFilePicker;
  var filePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);

  filePicker.init(window, strings.getString("choosesyncdir"), nsIFilePicker.modeGetFolder);

  if( filePicker.show() == nsIFilePicker.returnOK )
  {
    document.getElementById( "localpath" ).value = filePicker.file.path;
    document.getElementById( "synctype" ).selectedItem=document.getElementById( "synclocal" );
  }
} // ChoosePath

function PickedMsgFolder(selection) {
  var selectedUri = typeof selection=="string"?selection:selection.getAttribute('id');

  var picker=document.getElementById('syncimapPicker');
  var msgfolder = GetMsgFolderFromUri(selectedUri, true);
//TODO: if (selectedFolder.server.type != "imap")

  if (!msgfolder)
    return;

  var selectedValue = null;
  var serverName;

  if (msgfolder.isServer)
    selectedValue = msgfolder.name;
  else {
    if (msgfolder.server)
      serverName = msgfolder.server.prettyName;
    else {
     dump("Can't find server for " + uri + "\n");
     serverName = "???";
    }
    var gMessengerBundle = document.getElementById("bundle_messenger");
    selectedValue = gMessengerBundle.getFormattedString("verboseFolderFormat",
        [msgfolder.name, serverName]);
  }

  picker.setAttribute("label",selectedValue);
  picker.setAttribute("uri",selectedUri);
}

function SaveMab()
{
    var mabFile = document.getElementById( "MabList" ).selectedItem.value;
    var mabName = document.getElementById( "MabList" ).selectedItem.label;

    var nsIFilePicker = Components.interfaces.nsIFilePicker;
    var filePicker = Components.classes["@mozilla.org/filepicker;1"].
      createInstance(nsIFilePicker);

//old    var externMabFileName = mabName.replace( /\W/g, "_" ) + ".mab";
    var externMabFileName = mabName + ".mab";
    filePicker.defaultString = externMabFileName;
    filePicker.init(window, strings.getString("choosefiledest"), nsIFilePicker.modeSave);
    filePicker.appendFilter( strings.getString("mab") + " (*.mab)", "*.mab;" );
//    filePicker.appendFilter( 'CSV' + " (*.csv)", "*.csv;" );
//    filePicker.appendFilter( 'LDIF' + " (*.ldif)", "*.ldif;" );

    if( filePicker.show() != nsIFilePicker.returnCancel) { //Ok or Replace!
      var ret;
      switch (filePicker.filterIndex) {
        case 0:
          ret=saveMabFile( mabName, mabFile, filePicker.file.parent, filePicker.file.leafName );
          break;
/*  leider sind die export Funktionen von Javascript aus nicht zugnglich :-(
    lediglich ab.exportAddressBook() ist verfgbar, aber das poppt ein
    FilePicker auf
*/
/*
        case 1:
          var cur=getAddressBook(mabName);
          var ab = Components.classes["@mozilla.org/addressbook;1"].
            getService(Components.interfaces.nsIAddressBookExport);
          var file=filePicker.file;
          //TODO: eventuell umbenennen statt lschen
          if (file.exists() && file.isFile()) { file.remove(false); }
          ret=ab.ExportDirectoryToDelimitedText(cur,';',1,file);
          break;
        case 2:
          var cur=getAddressBook(mabName);
          var ab = Components.classes["@mozilla.org/addressbook;1"].
            getService(Components.interfaces.nsIAddressBookExport);
          var file=filePicker.file;
          //TODO: eventuell umbenennen statt lschen
          if (file.exists() && file.isFile()) { file.remove(false); }
          ret=ab.ExportDirectoryToLDIF(cur,file);
          break;
*/
        default:
          ret=false;
          break;
      }
      if (ret)
        alert(strings.getString('stored'));
      else
        alert(strings.getString('storefailed'));
    }
} //
function UploadMab()
{ //upload single mab from options menu
    var mabFile = document.getElementById( "MabList1" ).selectedItem.value;
    var mabName = document.getElementById( "MabList1" ).selectedItem.label;
    showPopup('upload', mabFile, false, false, true);
}

function LoadMab()
{
  // see comment with secureAddressbook() in addressbookssync.js
  if (secureAddressbook()) {
    setTimeout(LoadMab, 1000); // give window time to close
    return;
  }

  var filename = document.getElementById( "MabFilePath" ).value;
  if (!filename) return;

  var mabName = document.getElementById( "MabName" ).value;
  if (!mabName) return;

  var mabFile='';
  var create;

  var cur=getAddressBook(mabName);
  if (cur) {
    mabFile=cur.directoryProperties.fileName;
//    if (uri==kPersonalAddressbookURI || uri==kCollectedAddressbookURI) {
//      alert(strings.getString('nooverwrite'));
//      return;
//    }
//    if (!confirm(strings.getString('askoverwrite'))) return;
    if (askOverwrite(cur, true)) return;
    create=false;
  } else {
    //create mabFile name
    //  with policy=='file' it will be removed immediately, but must exist :-(
    mabFile = mabName.replace( /\W/g, "_" )+'.mab';
    createAddressBook( mabName, mabFile, false );
    create=true;
  }
  file = Components.classes["@mozilla.org/file/local;1"].
    createInstance(Components.interfaces.nsILocalFile);
  try{ file.initWithPath( filename ); }
  catch(e) {
    alert(strings.getString('nofile'));
    file=null;
  }
  if (file) {
    var ret;
    if ((ret=replaceAddressBook(mabName, mabFile, file))) {
      alert(strings.getString('notcopied')+' '+ret);
      file=null;
    }
  }
  if (file) {
    document.getElementById( "MabFilePath" ).value='';
    document.getElementById( "MabName" ).value='';
    if (create) abs_init(); // insert in options list
    alert(strings.getString('loaded'));
  } else if (create)
    deleteAddressBook(mabName, mabFile);
}
function DownloadMab()
{
  var mabName = document.getElementById( "DownloadMabName" ).value;
  if (!mabName) return;

  var mabFile='';

  var cur=getAddressBook(mabName);
  var create;
  if (cur) {
    mabFile=cur.directoryProperties.fileName;
//    if (!confirm(strings.getString('askoverwrite'))) return;
    if (askOverwrite(cur, true)) return;
//    create=false;
  } else {
    //create mabFile name
    //  with policy=='file' it will be removed immediately, but must exist :-(
    mabFile = mabName.replace( /\W/g, "_" )+'.mab';
    createAddressBook( mabName, mabFile, false );
    abs_init(); // insert in options list
//    create=true;
  }

//  document.getElementById("UseMabFile").value=mabFile;
//  document.getElementById("MabCreated").setAttribute('checked', create);
  showPopup('download', mabFile, false, false, true);
//TODO: in download() sollte kein test auf file modification stattfinden

}

function get_password(host, user){
    var dhost= new Object();
    var duser= new Object();
    var pass= new Object();
    try{
      var pmInternal = Components.classes["@mozilla.org/passwordmanager;1"]
                      .createInstance(Components.interfaces.nsIPasswordManagerInternal);
      var ret=pmInternal.findPasswordEntry(host,user,"",dhost,duser,pass);
      return pass.value;
    }catch(e){}
    return "";
}

function set_password(host, user, pwd){
//alert('set_password');
    var passwordManager = Components.classes["@mozilla.org/passwordmanager;1"]
            .createInstance(Components.interfaces.nsIPasswordManager);
    try{
      passwordManager.removeUser(host,user);
    }catch(e){}
    passwordManager.addUser(host,user,pwd);
}

function uploadNow(force)
{//called via button click, not via automatic upload at end
  abs_finish(); //ggf genderte Parameter bernehmen!
  if (gAddressbooksSync.synctype!='none')
    showPopup('upload', null, false, false, force);
}

function downloadNow(force)
{//called via button click, not via automatic download at start
  abs_finish(); //ggf genderte Parameter bernehmen!
  if (gAddressbooksSync.synctype!='none')
    showPopup('download', null, false, false, force);
}

function uploadThis()
{ //called via context menu
  if (gAddressbooksSync.synctype!='none') {
    var abDir=GetSelectedDirectory(); //the URI
    var dir = GetDirectoryFromURI(abDir);
    showPopup('upload', dir.directoryProperties.fileName, false, false, true);
//    else  // also checked via events.js
//alert('upload in progress');
  }
}

function downloadThis()
{ //called via context menu
  if (gAddressbooksSync.synctype!='none') {
    var abDir=GetSelectedDirectory(); //the URI
    var dir = GetDirectoryFromURI(abDir);
    showPopup('download', dir.directoryProperties.fileName, false, false, true);
//    else  // also checked via events.js
//alert('download in progress');

  }
}
