/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AddressbooksSynchronizer.
 *
 * The Initial Developer of the Original Code is Gnter Gersdorf.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Gnter Gersdorf <G.Gersdorf@ggbs.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var gLifeTime;//in seconds.
var abData=null;
var abURI=null;
var abMime='text/plain';
var ioService=Components.classes["@mozilla.org/network/io-service;1"]
               .getService(Components.interfaces.nsIIOService);
var strings;
var syncing;
var externalApp;
var externalAppHandler;

var cleanUp=null;
var gAbort=0;

var gForce;
var gCheckLastMod=true;
var gMabFiles;
var gCurMabFile;

var gTempName;

function uploadDone() {
dump('upload DONE\n');
  if (externalApp) {
    syncprotocol = pref.getCharPref("extensions.addressbookssync.protocol");
    if (externalApp==-1)
      pref.clearUserPref("network.protocol-handler.external."+syncprotocol);
    else
      pref.setBoolPref("network.protocol-handler.external."+syncprotocol, true);
  }
  if (externalAppHandler)
    pref.setCharPref("network.protocol-handler.app."+syncprotocol, externalAppHandler);
  externalApp=null;
  externalAppHandler=null;

  if (gAddressbooksSync.exiting) {
    var app = Components.classes["@mozilla.org/toolkit/app-startup;1"].
        getService(Components.interfaces.nsIAppStartup);
    app.exitLastWindowClosingSurvivalArea();
  }
}

function upload(singleBook, force)
{
dump('in upload appstart='+gAddressbooksSync.appstarttime+' state='+gAddressbooksSync.state+'\n');

  gLifeTime=3;
  gForce=force||gAddressbooksSync.forceUpload;
    gAddressbooksSync.forceUpload=false;
  gCheckLastMod = gAddressbooksSync.checkLastModTime;
  var synctype=gAddressbooksSync.synctype;

  syncing=true;
  gUsesPopup=window.location=='chrome://addressbookssync/content/upload.xul';
  if (gUsesPopup) {
    if (gAddressbooksSync.exiting && gAddressbooksSync.hideallpopups) {
      gLifeTime=0;
      var status=document.getElementById('statuswindow');
      status.style.display='none';
      window.resizeTo(0,0);     //es bleiben trotzdem ca. 10x50px brig
      window.sizeToContent(); //macht das Fenster durchsichtig :-)
    }
//    window.moveTo(0,0);
      //v could be removed in next version!
        var dialogElement = document.documentElement;
        dialogElement.removeAttribute("persist");
        dialogElement.removeAttribute("height");
        dialogElement.removeAttribute("width");
        dialogElement.removeAttribute("screenX");
        dialogElement.removeAttribute("screenY");
      //^
  }
  strings = document.getElementById("strings");

  statustxt(synctype, -1, false, 'Start upload ('+synctype+')');

  gAddressbooksSync.count=0;
  gMabFiles=(singleBook ? new Array(singleBook) : syncedAddressbooks('up'));

  cleanUp=uploadDone;
  if (synctype=='local') {
    if (gUsesPopup) setTimeout(sendLocalData, 0);   // give popup time to show up
    else sendLocalData();
  } else if (synctype=='remote') {
    abURI=getSyncURI(false);
    try{ syncprotocol = pref.getCharPref( "extensions.addressbookssync.protocol" ); }
      catch(e){ killMe();}
    try { externalApp=pref.getBoolPref("network.protocol-handler.external."+syncprotocol) }
      catch(e) { externalApp=-1; }
    if (externalApp) pref.setBoolPref("network.protocol-handler.external."+syncprotocol, false);
    //ubuntu seems to ignore the value of external.xxx, therefore:
    try {
      externalAppHandler=pref.getCharPref("network.protocol-handler.app."+syncprotocol);
      if (externalAppHandler) pref.clearUserPref("network.protocol-handler.app."+syncprotocol);
    } catch(e) { externalAppHandler=''; }
    if (!checkOffline('upload')) {
      killMe();
    } else {
      if (gUsesPopup) setTimeout(sendData, 0);
      else sendData();
    }
  } else if (synctype=='imap') {
    if (!checkOffline('upload')) {
      killMe();
    } else {
      if (gUsesPopup) setTimeout(imapSave, 0);
      else imapSave();
    }
  } else {
    killMe();
  }

}

function sendLocalData() {
  var localpath=pref.getCharPref( "extensions.addressbookssync.localpath" )
  if (localpath) {
    var dir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    dir.initWithPath( localpath );
    for (var i = 0; i < gMabFiles.length; i++) {
      if (gAbort) break;
      var mabFile=gMabFiles[i];
      var cur=getAddressBook(mabFile);
      var mabName=cur.directoryProperties.description;
      var uri = cur.directoryProperties.URI;

      var lmd = getLastModified(cur);
      var lmds='lastMod='+timeString(lmd*1000);
      if (!gAddressbooksSync.forcedUploadOf(mabFile) &&
          !gForce && gCheckLastMod && gAddressbooksSync.appstarttime>=lmd) {
        statustxt('- '+mabName+' '+strings.getString('skipped'), 3, false, null, lmds);
        continue;
      }

      var localFileName;
      if (!syncing || uri!=kPersonalAddressbookURI && uri!=kCollectedAddressbookURI)
        localFileName = mabName+'.mab'; //ex: =mabFile
      else
        localFileName = '_tb_'+cur.directoryProperties.fileName;

      statustxt('- '+mabName+'..', 1, false, null, lmds);
      if (saveMabFile(mabName, mabFile, dir, localFileName)) {
        statustxt(strings.getString('copied'), 2, false);
        gAddressbooksSync.forceUploadOf(mabFile, false);
        gAddressbooksSync.count+=1;
      } else
        statustxt(strings.getString('notcopied'), 2, true);
    }
  }
  killMe();
}

function sendData()
{
    while (true) {
      var mabFile=gMabFiles.pop();
      if (!mabFile || gAbort) {
        killMe();
        return;
      }
      var cur=getAddressBook(mabFile);
      var mabName=cur.directoryProperties.description;
      var uri = cur.directoryProperties.URI;

      var lmd = getLastModified(cur);
      var lmds='lastMod='+timeString(lmd*1000);
      if (!gAddressbooksSync.forcedUploadOf(mabFile) &&
          !gForce && gCheckLastMod && gAddressbooksSync.appstarttime>=lmd) {
        statustxt('- '+mabName+' '+strings.getString('skipped'), 3, false, null, lmds);
        continue;
      }
      break;
    }
    gCurMabFile=mabFile
    var remoteFileName;
    if (!syncing || uri!=kPersonalAddressbookURI && uri!=kCollectedAddressbookURI)
      remoteFileName = mabName+".mab";
    else
      remoteFileName = '_tb_'+cur.directoryProperties.fileName;

    statustxt('- '+mabName+".", 1, false, null, lmds);  // 1. dot: start

    var mabURI=abURI+remoteFileName;
    var URI=ioService.newURI(mabURI,null,null);

    nsIMabFile=getDir('ProfD');
    nsIMabFile.appendRelativePath( mabFile );
    abData=readMabData(nsIMabFile, gCheckLastMod);
    if (!abData) {
      uploadCallback("done",-2); // file does not exist
      return;
    }
    statustxt(".", 0, false); // 2. dot: file loaded

    var error=gBookmarksSynchronizerUploadService.start(abData, URI, abMime, uploadCallback);
    if(error)
      uploadCallback("done", error);
    else
      statustxt(".", 0, false); // 4. dot: upload start is finished
}

function uploadCallback(aStatus,aError)
{
  if (aStatus=='send') {  //called from within gBookmarksSynchronizerUploadService.start
    statustxt('.', 0, false); // 3. dot: upload started
    return;
  } else {  // upload finished (called with aStatus='done' from gBookmarksSynchronizerUploadService)
try { errorstr; } catch(e) { sendData(); return; }  //bei Upload at onUnload ohne popup fenster
                                                    //existiert hier errorstr() nicht mehr
                                                    //nicht einmal mehr sendData()!
    var error=errorstr(aError);
    if (error!=strings.getString('ok')) {
      statustxt(error, 2, true);
      gLifeTime=5;//in seconds.
//      killMe();
//      return;
    } else {
      statustxt(strings.getString('ok'), 2, false);
      gAddressbooksSync.forceUploadOf(gCurMabFile, false);
      gAddressbooksSync.count+=1;
    }
  }

    sendData(); //next addressbook
}

function cancelUpload()
{
  if (gAbort) {
    gAbort++;
    killMe();
  } else {
    gAbort++;
    document.getElementById("abs_cancel").label='kill';
  }
  // gBookmarksSynchronizerUploadService.cancel();  // no or we may left behind corrupted files
}

